<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:12 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>BuildCacheService (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="BuildCacheService (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/caching/BuildCacheKey.html" title="interface in org.gradle.caching"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/caching/BuildCacheServiceFactory.html" title="interface in org.gradle.caching"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/caching/BuildCacheService.html" target="_top">Frames</a></li>
<li><a href="BuildCacheService.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.caching</div>
<h2 title="Interface BuildCacheService" class="title">Interface BuildCacheService</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Superinterfaces:</dt>
<dd><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/io/Closeable.html?is-external=true" title="class or interface in java.io">Closeable</a></dd>
</dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../../org/gradle/caching/MapBasedBuildCacheService.html" title="class in org.gradle.caching">MapBasedBuildCacheService</a></dd>
</dl>
<hr>
<br>
<pre><a href="../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">BuildCacheService</span>
extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/Closeable.html?is-external=true" title="class or interface in java.io">Closeable</a></pre>
<div class="block">Protocol interface to be implemented by a client to a build cache backend.

 <p>
     Build cache implementations should report a non-fatal failure as a <a href="../../../org/gradle/caching/BuildCacheException.html" title="class in org.gradle.caching"><code>BuildCacheException</code></a>.
     Non-fatal failures could include failing to retrieve a cache entry or unsuccessfully completing an upload a new cache entry.
     Gradle will not fail the build when catching a <code>BuildCacheException</code>, but it may disable caching for the build if too
     many failures occur.
 </p>
 <p>
     All other failures will be considered fatal and cause the Gradle build to fail.
     Fatal failures could include failing to read or write cache entries due to file permissions, authentication or corruption errors.
 </p>
 <p>
     Every build cache implementation should define a <a href="../../../org/gradle/caching/configuration/BuildCache.html" title="interface in org.gradle.caching.configuration"><code>BuildCache</code></a> configuration and <a href="../../../org/gradle/caching/BuildCacheServiceFactory.html" title="interface in org.gradle.caching"><code>BuildCacheServiceFactory</code></a> factory.
 </p></div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>3.5</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/caching/BuildCacheService.html#close()">close</a></strong>()</code>
<div class="block">Clean up any resources held by the cache once it's not used anymore.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/caching/BuildCacheService.html#load(org.gradle.caching.BuildCacheKey,%20org.gradle.caching.BuildCacheEntryReader)">load</a></strong>(<a href="../../../org/gradle/caching/BuildCacheKey.html" title="interface in org.gradle.caching">BuildCacheKey</a>&nbsp;key,
    <a href="../../../org/gradle/caching/BuildCacheEntryReader.html" title="interface in org.gradle.caching">BuildCacheEntryReader</a>&nbsp;reader)</code>
<div class="block">Load the cached entry corresponding to the given cache key.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/caching/BuildCacheService.html#store(org.gradle.caching.BuildCacheKey,%20org.gradle.caching.BuildCacheEntryWriter)">store</a></strong>(<a href="../../../org/gradle/caching/BuildCacheKey.html" title="interface in org.gradle.caching">BuildCacheKey</a>&nbsp;key,
     <a href="../../../org/gradle/caching/BuildCacheEntryWriter.html" title="interface in org.gradle.caching">BuildCacheEntryWriter</a>&nbsp;writer)</code>
<div class="block">Store the cache entry with the given cache key.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="load(org.gradle.caching.BuildCacheKey, org.gradle.caching.BuildCacheEntryReader)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>load</h4>
<pre>boolean&nbsp;load(<a href="../../../org/gradle/caching/BuildCacheKey.html" title="interface in org.gradle.caching">BuildCacheKey</a>&nbsp;key,
           <a href="../../../org/gradle/caching/BuildCacheEntryReader.html" title="interface in org.gradle.caching">BuildCacheEntryReader</a>&nbsp;reader)
             throws <a href="../../../org/gradle/caching/BuildCacheException.html" title="class in org.gradle.caching">BuildCacheException</a></pre>
<div class="block">Load the cached entry corresponding to the given cache key. The <code>reader</code> will be called if an entry is found in the cache.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>key</code> - the cache key.</dd><dd><code>reader</code> - the reader to read the data corresponding to the cache key.</dd>
<dt><span class="strong">Returns:</span></dt><dd><code>true</code> if an entry was found, <code>false</code> otherwise.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../org/gradle/caching/BuildCacheException.html" title="class in org.gradle.caching">BuildCacheException</a></code> - if the cache fails to load a cache entry for the given key</dd></dl>
</li>
</ul>
<a name="store(org.gradle.caching.BuildCacheKey, org.gradle.caching.BuildCacheEntryWriter)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>store</h4>
<pre>void&nbsp;store(<a href="../../../org/gradle/caching/BuildCacheKey.html" title="interface in org.gradle.caching">BuildCacheKey</a>&nbsp;key,
         <a href="../../../org/gradle/caching/BuildCacheEntryWriter.html" title="interface in org.gradle.caching">BuildCacheEntryWriter</a>&nbsp;writer)
           throws <a href="../../../org/gradle/caching/BuildCacheException.html" title="class in org.gradle.caching">BuildCacheException</a></pre>
<div class="block">Store the cache entry with the given cache key. The <code>writer</code> will be called to actually write the data.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>key</code> - the cache key.</dd><dd><code>writer</code> - the writer to write the data corresponding to the cache key.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../org/gradle/caching/BuildCacheException.html" title="class in org.gradle.caching">BuildCacheException</a></code> - if the cache fails to store a cache entry for the given key</dd></dl>
</li>
</ul>
<a name="close()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>close</h4>
<pre>void&nbsp;close()
           throws <a href="https://docs.oracle.com/javase/7/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Clean up any resources held by the cache once it's not used anymore.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/AutoCloseable.html?is-external=true#close()" title="class or interface in java.lang">close</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a></code></dd>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="https://docs.oracle.com/javase/7/docs/api/java/io/Closeable.html?is-external=true#close()" title="class or interface in java.io">close</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/7/docs/api/java/io/Closeable.html?is-external=true" title="class or interface in java.io">Closeable</a></code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/7/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if the cache fails to close cleanly.</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/caching/BuildCacheKey.html" title="interface in org.gradle.caching"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/caching/BuildCacheServiceFactory.html" title="interface in org.gradle.caching"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/caching/BuildCacheService.html" target="_top">Frames</a></li>
<li><a href="BuildCacheService.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
